# coding: utf-8

"""
    3Di API

    3Di simulation API (latest stable version: v3)   Framework release: 3.3.4   3Di core release: 3.3.1  deployed on:  08:44AM (UTC) on December 14, 2023  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: info@nelen-schuurmans.nl
    Generated by: https://openapi-generator.tech
"""


import logging
import pprint
import re  # noqa: F401

import six

from threedi_api_client.openapi.configuration import Configuration

logger = logging.getLogger(__name__)

class CreateThreedimodel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'inherit_from_previous_threedimodel': 'bool',
        'inherit_from_previous_revision': 'bool'
    }

    attribute_map = {
        'inherit_from_previous_threedimodel': 'inherit_from_previous_threedimodel',
        'inherit_from_previous_revision': 'inherit_from_previous_revision'
    }

    def __init__(self, inherit_from_previous_threedimodel=True, inherit_from_previous_revision=False, local_vars_configuration=None, fetched_from_api=False):  # noqa: E501
        """CreateThreedimodel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        # True if data is coming from API
        self._fetched_from_api = fetched_from_api

        self._inherit_from_previous_threedimodel = None
        self._inherit_from_previous_revision = None
        self.discriminator = None

        if inherit_from_previous_threedimodel is not None:
            self.inherit_from_previous_threedimodel = inherit_from_previous_threedimodel
        if inherit_from_previous_revision is not None:
            self.inherit_from_previous_revision = inherit_from_previous_revision

    @property
    def inherit_from_previous_threedimodel(self):
        """Gets the inherit_from_previous_threedimodel of this CreateThreedimodel.  # noqa: E501

        Try to inherit simulation templates from previous threedimodel (in case of regenerate)  # noqa: E501

        :return: The inherit_from_previous_threedimodel of this CreateThreedimodel.  # noqa: E501
        :rtype: bool
        """
        return self._inherit_from_previous_threedimodel

    @inherit_from_previous_threedimodel.setter
    def inherit_from_previous_threedimodel(self, inherit_from_previous_threedimodel):
        """Sets the inherit_from_previous_threedimodel of this CreateThreedimodel.

        Try to inherit simulation templates from previous threedimodel (in case of regenerate)  # noqa: E501

        :param inherit_from_previous_threedimodel: The inherit_from_previous_threedimodel of this CreateThreedimodel.  # noqa: E501
        :type: bool
        """

        self._inherit_from_previous_threedimodel = inherit_from_previous_threedimodel

    @property
    def inherit_from_previous_revision(self):
        """Gets the inherit_from_previous_revision of this CreateThreedimodel.  # noqa: E501

        Try to inherit simulation templates from previous revision  # noqa: E501

        :return: The inherit_from_previous_revision of this CreateThreedimodel.  # noqa: E501
        :rtype: bool
        """
        return self._inherit_from_previous_revision

    @inherit_from_previous_revision.setter
    def inherit_from_previous_revision(self, inherit_from_previous_revision):
        """Sets the inherit_from_previous_revision of this CreateThreedimodel.

        Try to inherit simulation templates from previous revision  # noqa: E501

        :param inherit_from_previous_revision: The inherit_from_previous_revision of this CreateThreedimodel.  # noqa: E501
        :type: bool
        """

        self._inherit_from_previous_revision = inherit_from_previous_revision

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def __handle_validation_error(self, message):
        # Only raise ValueError when not fetched from API
        from threedi_api_client import __version__ as VERSION

        if not self._fetched_from_api:
            raise ValueError(message + f" It is possible that the current threedi-api-client version ({VERSION}) is out of date: consult https://pypi.org/project/threedi-api-client/ and consider upgrading.")  # noqa: E501
        logger.warning(message + " Please update to the latest threedi-api-client version.")  # noqa: E501

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateThreedimodel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateThreedimodel):
            return True

        return self.to_dict() != other.to_dict()
